;==========================================================================
; This code demonstrates the use of a LookUp Table stored in Program Memory
; using indirect addressing techniques to display interesting LED patterns
; 2009 04 24
; C. D'Arcy
;==========================================================================
.include	"tn24def.inc"
; Defines==================================================================
.def	temp=R16
.org		0x0000
			rjmp	Reset
; Table of LED Patterns====================================================
LUT:
	.db	0b11111110, 0b11111101
	.db	0b11111011,	0b11110111
	.db	0b11101111,	0b11011111
	.db	0b10111111,	0b01111111
	.db	0b01111110,	0b01111101
	.db	0b01111011,	0b01110111
	.db	0b01101111,	0b01011111
	.db	0b00111111,	0b00111110
	.db	0b00111101,	0b00111011
	.db	0b00110111,	0b00101111
	.db	0b00011111,	0b00011110
	.db	0b00011101,	0b00011011
	.db	0b00010111,	0b00001111
	.db	0b00001110,	0b00001101
	.db	0b00001011,	0b00000111
	.db	0b00000110,	0b00000101
	.db	0b00000011,	0b00000010
	.db	0b00000001,	0b00000000
LUTEnd:
Reset:	ldi		temp,RAMEND			;To support subroutine call/return mechanisms
		out		SPL,temp			; set the Stack pointer to the highest address in DataRAM

		ldi		XH,high(LUT<<1)
		ldi		XL,low(LUT<<1)
		ldi		YH,high(LUTEnd<<1)
		ldi		YL,low(LUTEnd<<1)
		
		ldi		temp,0xFF
		out		DDRA,temp

Top:	clr		ZH	
		mov		ZL,XL
Next:	lpm		temp,Z+
		out		PORTA,temp
		rcall	Delay
		cp		ZL,YL
		brne	Next
		rjmp	Top

Delay:
; ============================= 
;    delay loop generator 
;     100000 cycles:
; ----------------------------- 
; delaying 99990 cycles:
          ldi  R17, $A5
WGLOOP0:  ldi  R18, $C9
WGLOOP1:  dec  R18
          brne WGLOOP1
          dec  R17
          brne WGLOOP0
; ----------------------------- 
; delaying 9 cycles:
          ldi  R17, $03
WGLOOP2:  dec  R17
          brne WGLOOP2
; ----------------------------- 
; delaying 1 cycle:
          nop
; ============================= 
			ret

  
